<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');

function om_warnings_generate_warnings_cache()
{
	global $forum_db;

	$query = array(
		'SELECT'	=> 'id, user_id, post_id, topic_id, reporter, reporter_id, expire_date, created, message, read_at',
		'FROM'		=> 'om_warnings_reports',
		'WHERE'		=> 'expire_date IS NULL OR expire_date > '.time(),
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$warnings = array();
	while ($cur_warnings = $forum_db->fetch_assoc($result)) {
		$warnings[] = $cur_warnings;
	}

	if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/cache.php';

	if (!write_cache_file(FORUM_CACHE_DIR.'cache_om_warnings.php', '<?php'."\n\n".'if (!defined(\'OM_WARNINGS_CACHE_LOADED\')) define(\'OM_WARNINGS_CACHE_LOADED\', 1);'."\n\n".'$om_warnings = '.var_export($warnings, true).';'."\n\n".'?>'))
	{
		error('Unable to write configuration cache file to cache directory.<br />Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);
	}
}

function om_warnings_check_expire_warnings()
{
	global $forum_db;

	if (!file_exists(FORUM_CACHE_DIR.'cache_om_warnings.php'))
		om_warnings_generate_warnings_cache();

	require FORUM_CACHE_DIR.'cache_om_warnings.php';

	if (isset($om_warnings) && count($om_warnings)>0) 
	{
	    $warning_altered = false;
		
		foreach ($om_warnings as $cur_warning)
	    {
		    if ($cur_warning['expire_date'] != null && $cur_warning['expire_date'] <= time())
		    {
			    $query = array(
				    'DELETE'	=> 'om_warnings_reports',
		            'WHERE'		=> 'id='.$cur_warning['id']
			    );
			    $forum_db->query_build($query) or error(__FILE__, __LINE__);

			    $warning_altered = true;
			    continue;
			}
		}

	    if ($warning_altered)
	    {
		    om_warnings_generate_warnings_cache();
	    }
	}
}

function om_warnings_delete_expire_warnings() 
{
	global $forum_db;

	$query = array(
        'DELETE'	=> 'om_warnings_reports',
		'WHERE'		=> 'expire_date IS NOT NULL AND expire_date < '.time()
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
}

define('OM_WARNINGS_ADDITION_FUNCTIONS_LOADED', 1);
